#pragma once
#ifndef __OpenGLStream_H__
#define __OpenGLStream_H__

class OpenGLStream
{
public:
	OpenGLStream(Vector2n CaretPosition);
	~OpenGLStream();
	
	OpenGLStream & operator << (const Concept & Concept);
	OpenGLStream & operator << (const std::string & String);
	OpenGLStream & operator << (OpenGLStream & (*Function)(OpenGLStream &));
	
	void NewLine();

private:
	OpenGLStream(const OpenGLStream &);
	OpenGLStream & operator =(const OpenGLStream &);

	Vector2n		m_CaretPosition;
	sint32			m_LineStartX;
};

OpenGLStream & endl(OpenGLStream & stream);

#endif // __OpenGLStream_H__
