#include "Main.h"

Project::Project()
	: std_includes(),
	  functions2()
{
}

Project::~Project()
{
}

void Project::LoadSampleGenProgram()
{
	//std_includes.push_back(FindConcept("iostream"));

	{
		func2 printhi_func2;
		printhi_func2.Position = Vector2n(-400, -200);
		printhi_func2.name.push_back(17);
		printhi_func2.args.push_back(FindConcept(""));
		printhi_func2.return_type.push_back(FindConcept("void"));

		printhi_func2.body_lines.push_back(1);
		printhi_func2.body_lines.push_back(FindConcept("<<"));
		printhi_func2.body_lines.push_back(3);
		printhi_func2.body_lines.push_back(FindConcept("<<"));
		printhi_func2.body_lines.push_back(FindConcept("\" & size of pointer == \""));
		printhi_func2.body_lines.push_back(FindConcept("<<"));
		printhi_func2.body_lines.push_back(FindConcept("sizeof"));
		printhi_func2.body_lines.push_back(FindConcept("("));
		printhi_func2.body_lines.push_back(FindConcept("void"));
		printhi_func2.body_lines.push_back(FindConcept("*"));
		printhi_func2.body_lines.push_back(FindConcept(")"));
		printhi_func2.body_lines.push_back(FindConcept("<<"));
		printhi_func2.body_lines.push_back(10);
		printhi_func2.body_lines.push_back(FindConcept(";"));

		functions2.push_back(printhi_func2);
	}

	{
		func2 main_func2;
		main_func2.Position = Vector2n(-450, 100);
		main_func2.name.push_back(FindConcept("main"));
		main_func2.args.push_back(FindConcept("int"));
		main_func2.args.push_back(FindConcept("argc"));
		main_func2.args.push_back(FindConcept(","));
		main_func2.args.push_back(FindConcept("char"));
		main_func2.args.push_back(FindConcept("*"));
		main_func2.args.push_back(FindConcept("argv"));
		main_func2.args.push_back(FindConcept("["));
		main_func2.args.push_back(FindConcept("]"));
		main_func2.return_type.push_back(FindConcept("int"));

		main_func2.body_lines.push_back(17);
		main_func2.body_lines.push_back(FindConcept("("));
		main_func2.body_lines.push_back(FindConcept(")"));
		main_func2.body_lines.push_back(FindConcept(";"));
		main_func2.body_lines.push_back(FindConcept("return"));
		main_func2.body_lines.push_back(FindConcept("0"));
		main_func2.body_lines.push_back(FindConcept(";"));

		functions2.push_back(main_func2);
	}
}

void Project::Render()
{
	for (auto it = functions2.begin(); it != functions2.end(); ++it)
	{
		DrawFunction2(*it);
	}

	// Draw std_includes
	/*{
		Vector2n Position(-200, -300);
		Vector2n Size(8 * charWidth, std_includes.size() * lineHeight);

		DrawBox(Position, Size);
		
		std::string Description[2] = { "#include <", ">" };
		glColor3d(0, 0, 0); OglUtilsPrint(Position.X(), Position.Y(), 0, RIGHT, Description[0].c_str());
		glColor3d(0, 0, 0); OglUtilsPrint(Position.X() + Size.X(), Position.Y(), 0, LEFT, Description[1].c_str());

		OpenGLStream OpenGLStream(Position);
		//for (vector<string>::size_type i = 0; i < std_includes.size(); ++i)
		for (auto & Entry : std_includes)
		{
			//glColor3d(0, 0, 0); OglUtilsPrint(Position.X(), Position.Y() + static_cast<sint32>(i) * lineHeight, 0, LEFT, std_includes.at(i).c_str());
			OpenGLStream << Concepts[Entry] << endl;
		}
	}*/
}

void Project::DrawFunction2(func2 & f) const
{
	DrawBox(f.Position, Vector2n(904, (3 + 2/*f.body_lines.size()*/) * lineHeight));
	
	glColor3d(0, 0, 0); OglUtilsPrint(f.Position.X(), f.Position.Y() - lineHeight, 0, LEFT, "Global Function");

	OpenGLStream OpenGLStream(f.Position);
	OpenGLStream << f;
}

void Project::GenerateProgram()
{
	std::ofstream out("GenProgram.cpp");

	for (uint32 i = 0; i < std_includes.size(); ++i)
	{
		out << "#include <" << Concepts[std_includes.at(i)] << ">" << endl;
	}

	for (uint32 i = 0; i < functions2.size(); ++i)
	{
		out << endl;

		func2 f = functions2.at(i);

		out << f;
	}

	out.close();
}

void Project::RunProgram()
{
#ifdef WIN32
	STARTUPINFO StartupInfo;
	memset(&StartupInfo, 0, sizeof(StartupInfo));
	StartupInfo.cb = sizeof(StartupInfo);

	PROCESS_INFORMATION ProcessInfo;
	memset(&ProcessInfo, 0, sizeof(ProcessInfo));

	LPTSTR CommandLine = "cmd.exe /C \"C:\\Program Files (x86)\\Microsoft Visual Studio 11.0\\VC\\vcvarsall.bat\" amd64 & (cl GenProgram.cpp >NUL 2>NUL && GenProgram || echo Compilation error.) & pause & del GenProgram.*";
	auto Result = CreateProcess(NULL, CommandLine, NULL, NULL, FALSE, CREATE_NEW_CONSOLE, NULL, NULL, &StartupInfo, &ProcessInfo);
#endif
}
