#pragma once
#ifndef __ListWidget_H__
#define __ListWidget_H__

class ListWidget
	: public Widget
{
public:
	ListWidget(Vector2n Position, std::vector<ConceptId> & List);
	virtual ~ListWidget();
	
	virtual void Render(WidgetManager & WidgetManager);

	virtual void Clicked();
	
private:
	Vector2n GetDimensions() const;

	// TODO: Template this specific class to typename <T>
	std::vector<ConceptId>		& m_List;
};

#endif // __ListWidget_H__
